import 'dart:async';
import 'dart:convert';
import 'package:libui/assets/assets.dart' as assets;

class I18nModel {
  String localeId;

  String pageName;

  Map<String, dynamic> localization = Map<String, dynamic>();

  Future<void> load(String locale, String page) async {
    if (locale != localeId || page != pageName) {
      localization.clear();
      String jsonContent = await assets.load('i18n/${page}_$locale.json');
      localization = json.decode(jsonContent);
      localeId = locale;
      pageName = page;
    }
  }
}
